In last episode, we finished up minimax strategy for Connect-N games,
including Tic-Tac-Toe and Gomoku. This episode, we will implement its
GUI environment based on Pygame library for human vs. human, AI vs. AI
or human vs. AI plays, which is essential for self-play AlphaGo Zero
reinforcement learning. The environment is further embedded into OpenAI
Gym as it's the standard in game reinforcement learning. All code in
this series is in ConnectNGym
github.
Python has several well-known multi-platform GUI libraries such as
Tkinter, PyQt. They are mainly targeted at desktop GUI programming,
whose API family is complicated and learning curve is steep. In
contrast, Pygame is tailored specifically for desktop small game
development so we adopt it. ### Pygame 101
Pygame is, no exceptionally, the same as all GUI development, that is
based on single thread event driven model. Here is the simplest desktop
Pygame application showing a window. while True infinitely retrieves
events dispatched by OS to the window. In the example, we only handle
quit event (user clicking on close button) to exit the whole process. In
addition, clock variable controls FPS, which we won't elaborate on.
whileTrue: for event in pygame.event.get(): if event.type == pygame.QUIT: sys.exit(0) else: pygame.display.update() clock.tick(1)
PyGameBoard Class
PyGameBoard class encapsulates GUI interaction and rendering logics.
In last episode, we have coded ConnectNGame class. PyGameBoard is
instantiated with a pre-initialized ConnectNGame instance. It handles
GUI mouse event to determine next valid move and then further
manipulates its internal state, which is just the ConnectNGame instance
passed in. Concretely, PyGameBoard instance method,
next_user_input(self) loops until a valid action is identified by
current player.
Following Pygame 101, method check_event() handles events dispatched
by OS and only player mouse event is consumed. Method
_handle_user_input() converts mouse event into row and column indices,
validates the move and returns the move in the form of Tuple[int, int].
For instance, (0, 0) is the upper left corner position.
defcheck_event(self): for e in pygame.event.get(): if e.type == pygame.QUIT: pygame.quit() sys.exit(0) elif e.type == pygame.MOUSEBUTTONDOWN: self._handle_user_input(e) def_handle_user_input(self, e: Event) -> Tuple[int, int]: origin_x = self.start_x - self.edge_size origin_y = self.start_y - self.edge_size size = (self.board_size - 1) * self.grid_size + self.edge_size * 2 pos = e.pos if origin_x <= pos[0] <= origin_x + size and origin_y <= pos[1] <= origin_y + size: ifnot self.connectNGame.gameOver: x = pos[0] - origin_x y = pos[1] - origin_y r = int(y // self.grid_size) c = int(x // self.grid_size) valid = self.connectNGame.checkAction(r, c) if valid: self.action = (r, c) return self.action
Integrated into OpenAI Gym
OpenAI Gym specifies how Agent interacts with Env. Env is defined as
gym.Env and the major task of creating a new game Environment is
subclassing it and overriding reset, step and render methods. Let's see
how our ConnectNGym looks like.
defreset(self) -> ConnectNGame: """Resets the state of the environment and returns an initial observation. Returns: observation (object): the initial observation. """ raise NotImplementedError
defstep(self, action: Tuple[int, int]) -> Tuple[ConnectNGame, int, bool, None]: """Run one timestep of the environment's dynamics. When end of episode is reached, you are responsible for calling `reset()` to reset this environment's state. Accepts an action and returns a tuple (observation, reward, done, info). Args: action (object): an action provided by the agent Returns: observation (object): agent's observation of the current environment reward (float) : amount of reward returned after previous action done (bool): whether the episode has ended, in which case further step() calls will return undefined results info (dict): contains auxiliary diagnostic information (helpful for debugging, and sometimes learning) """ raise NotImplementedError
defrender(self, mode='human'): """ Renders the environment. The set of supported modes varies per environment. (And some environments do not support rendering at all.) By convention, if mode is: - human: render to the current display or terminal and return nothing. Usually for human consumption. - rgb_array: Return an numpy.ndarray with shape (x, y, 3), representing RGB values for an x-by-y pixel image, suitable for turning into a video. - ansi: Return a string (str) or StringIO.StringIO containing a terminal-style text representation. The text can include newlines and ANSI escape sequences (e.g. for colors). Note: Make sure that your class's metadata 'render.modes' key includes the list of supported modes. It's recommended to call super() in implementations to use the functionality of this method. Args: mode (str): the mode to render with """ raise NotImplementedError
Method reset()
1
defreset(self) -> ConnectNGame
Resets environment internal state and returns corresponding initial
status that can be observed by agent. ConnectNGym holds an instance of
ConnectNGame as its internal state and because of the complete
observability property in any board games, the observable state by agent
is exactly the same as board game internal state. So we return a
deepcopy of ConnectNGame instance in reset().
Once the agent selects an action and hands back to env, env would
execute the action and change its internal state via step() and returns
following four items.
The new state observed by the agent
The reward associated with the action
Environment terminated or not
Other auxiliary information
step() is the most core API of gym.Env. We illustrate a sequence of
game state transitions together with input and output
Initial State:
Agent A selects action = (0, 0). ConnectNGym.step() executes the
action and returns
The following animation shows two minimax AI players playing
Tic-Tac-Toe game (k=3,m=n=3). We know the conclusion from previous
episode that Tic-Tac-Toe is solved to be a draw, meaning when two
players both play optimal strategy, the first player is forced tie by
second one, which corresponds to animation result.
Game State Rotation
Enhancement
In last episode, we have confirmed Tic-Tac-Toe has 5478 total states.
The number grows exponentially as k, m and n increase. For instance, in
case where k=3, m=n=4 the total state number is 6035992 whereas k=4,
m=n=4 it's 9722011. We could improve Minimax DP strategy by pruning
those game states that are rotated from one solved game state. That is,
once a game state is solved, we not only cache this game state but also
cache other three game states derived by rotation that share the same
result.
For example, game state below has same result as other three rotated
ones.
{linenos
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17
defsimilarStatus(self, status: Tuple[Tuple[int, ...]]) -> List[Tuple[Tuple[int, ...]]]: ret = [] rotatedS = status for _ inrange(4): rotatedS = self.rotate(rotatedS) ret.append(rotatedS) return ret
defrotate(self, status: Tuple[Tuple[int, ...]]) -> Tuple[Tuple[int, ...]]: N = len(status) board = [[ConnectNGame.AVAILABLE] * N for _ inrange(N)]
for r inrange(N): for c inrange(N): board[c][N - 1 - r] = status[r][c]
returntuple([tuple(board[i]) for i inrange(N)])
Minimax Strategy
Precomputation
In last version of Minimax DP strategy implementation, we searched
best game result given a game state. In the computation, we also
leveraged pruning to shortcut if the result is already best. However,
for AI agent, we still have to call minimax for each new game state
encountered. This is very inefficient because we are solving same game
states again and again during top down recursion. An obvious improvement
is to compute all game states in first step and cache them all. Later
for each given state encountered, we only need to aggregate result by
looking at all possible next move positions of that game state. Code of
aggregating possible moves is listed below.
defaction(self, game: ConnectNGame) -> Tuple[int, Tuple[int, int]]: game = copy.deepcopy(game)
player = game.currentPlayer bestResult = player * -1# assume opponent win as worst result bestMove = None for move in game.getAvailablePositions(): game.move(*move) status = game.getStatus() game.undo()
result = self.dpMap[status]
if player == ConnectNGame.PLAYER_A: bestResult = max(bestResult, result) else: bestResult = min(bestResult, result) # update bestMove if any improvement bestMove = move if bestResult == result else bestMove print(f'move {move} => {result}')
return bestResult, bestMove
Agent Class and Playing
Logic
We also construct Agent class hierarchy, allowing AI player and human
player to share common code.
BaseAgent is the root class with default act() method being making
random decisions over all available actions.
This episode extends last one, where Minimax and Alpha Beta Pruning
algorithms are introduced. We will solve several tic-tac-toe problems in
leetcode, gathering intuition and building blocks for tic-tac-toe game
logic, which can be naturally extended to Connect-N game or Gomoku
(N=5). Then we solve tic-tac-toe using Minimax and Alpha Beta pruning
for small N and analyze their state space. In the following episodes,
based on building blocks here, we will implement a Connect-N Open Gym
GUI Environment, where we can play against computer visually or compare
different computer algorithms. Finally, we demonstrate how to implement
a Monte Carlo Tree Search for Connect-N Game.
Tic-tac-toe is played by two players A and B on a 3 x 3 grid.
Here are the rules of Tic-Tac-Toe: Players take turns placing
characters into empty squares (" "). The first player A always
places "X" characters, while the second player B always places "O"
characters. "X" and "O" characters are always placed into empty
squares, never on filled ones. The game ends when there are 3 of
the same (non-empty) character filling any row, column, or
diagonal. The game also ends if all squares are non-empty. No
more moves can be played if the game is over. Given an array moves where
each element is another array of size 2 corresponding to the row and
column of the grid where they mark their respective character in the
order in which A and B play. Return the winner of the game if it
exists (A or B), in case the game ends in a draw return "Draw", if there
are still movements to play return "Pending". You can assume that
moves is valid (It follows the rules of Tic-Tac-Toe), the grid is
initially empty and A will play first.
Example 1: Input: moves = [[0,0],[2,0],[1,1],[2,1],[2,2]]
Output: "A" Explanation: "A" wins, he always plays first. "X "
"X " "X " "X " "X " " " -> " " -> " X " -> " X " -> " X
" " " "O " "O " "OO " "OOX"
Example 3: Input: moves =
[[0,0],[1,1],[2,0],[1,0],[1,2],[2,1],[0,1],[0,2],[2,2]] Output:
"Draw" Explanation: The game ends in a draw since there are no
moves to make. "XXO" "OOX" "XOX"
Example 4: Input: moves = [[0,0],[1,1]] Output:
"Pending" Explanation: The game has not finished yet. "X
" " O " " "
The intuitive solution is to permute all 8 possible winning
conditions: 3 vertical lines, 3 horizontal lines and 2 diagonal lines.
We keep 8 variables representing each winning condition and a simple
trick is converting board state to a 3x3 2d array, whose cell has value
-1, 1, and 0. In this way, we can traverse the board state exactly once
and in the process determine all 8 variables value by summing
corresponding cell value. For example, row[0] is for first line winning
condition, summed by all 3 cells in first row during board traveral. It
indicates win for first player only when it's equal to 3 and win for
second player when it's -3.
classSolution: deftictactoe(self, moves: List[List[int]]) -> str: board = [[0] * 3for _ inrange(3)] for idx, xy inenumerate(moves): player = 1if idx % 2 == 0else -1 board[xy[0]][xy[1]] = player
turn = 0 row, col = [0, 0, 0], [0, 0, 0] diag1, diag2 = False, False for r inrange(3): for c inrange(3): turn += board[r][c] row[r] += board[r][c] col[c] += board[r][c] if r == c: diag1 += board[r][c] if r + c == 2: diag2 += board[r][c]
oWin = any(row[r] == 3for r inrange(3)) orany(col[c] == 3for c inrange(3)) or diag1 == 3or diag2 == 3 xWin = any(row[r] == -3for r inrange(3)) orany(col[c] == -3for c inrange(3)) or diag1 == -3or diag2 == -3
Below we give another AC solution. Despite more code, it's more
efficient than previous one because for a given game state, it does not
need to visit each cell on the board. How is it achieved? The problem
guarentees each move is valid, so what's sufficent to examine is to
check neighbours of the final move and see if any line including final
move creates a winning condition. Later we will reuse the code in this
solution to create tic-tac-toe game logic.
if (north + south + 1 >= 3) or (east + west + 1 >= 3) or \ (south_east + north_west + 1 >= 3) or (north_east + south_west + 1 >= 3): returnTrue returnFalse
defgetConnectedNum(self, r: int, c: int, dr: int, dc: int) -> int: player = self.board[r][c] result = 0 i = 1 whileTrue: new_r = r + dr * i new_c = c + dc * i if0 <= new_r < 3and0 <= new_c < 3: if self.board[new_r][new_c] == player: result += 1 else: break else: break i += 1 return result
deftictactoe(self, moves: List[List[int]]) -> str: self.board = [[0] * 3for _ inrange(3)] for idx, xy inenumerate(moves): player = 1if idx % 2 == 0else -1 self.board[xy[0]][xy[1]] = player
# only check last move r, c = moves[-1] win = self.checkWin(r, c) if win: return"A"iflen(moves) % 2 == 1else"B"
A Tic-Tac-Toe board is given as a string array board. Return True if
and only if it is possible to reach this board position during the
course of a valid tic-tac-toe game. The board is a 3 x 3 array, and
consists of characters " ", "X", and "O". The " " character represents
an empty square. Here are the rules of Tic-Tac-Toe: Players
take turns placing characters into empty squares (" "). The first
player A always places "X" characters, while the second player B always
places "O" characters. "X" and "O" characters are always placed
into empty squares, never on filled ones. The game ends when there
are 3 of the same (non-empty) character filling any row, column, or
diagonal. The game also ends if all squares are non-empty. No
more moves can be played if the game is over.
Example 1: Input: board = ["O ", " ", " "] Output:
false Explanation: The first player always plays "X".
Example 2: Input: board = ["XOX", " X ", " "] Output:
false Explanation: Players take turns making moves.
Example 4: Input: board = ["XOX", "O O", "XOX"] Output:
true
Note: board is a length-3 array of strings, where each string
board[i] has length 3. Each board[i][j] is a character in the set
{" ", "X", "O"}.
Surely, it can be solved using DFS, checking if the state given would
be reached from initial state. However, this involves lots of states to
search. Could we do better? There are obvious properties we can rely on.
For example, the number of X is either equal to the number of O or one
more. If we can enumerate a combination of necessary and sufficient
conditions of checking its reachability, we can solve it in O(1) time
complexity.
Design a Tic-tac-toe game that is played between two players on a n x
n grid. You may assume the following rules: A move is
guaranteed to be valid and is placed on an empty block. Once a
winning condition is reached, no more moves is allowed. A player
who succeeds in placing n of their marks in a horizontal, vertical, or
diagonal row wins the game.
Example: Given n = 3, assume that player 1 is "X" and player 2
is "O" in the board. TicTacToe toe = new TicTacToe(3);
toe.move(0, 0, 1); -> Returns 0 (no one wins) |X| | | | | |
| // Player 1 makes a move at (0, 0). | | | |
toe.move(0, 2, 2); -> Returns 0 (no one wins) |X| |O| | | |
| // Player 2 makes a move at (0, 2). | | | |
toe.move(2, 2, 1); -> Returns 0 (no one wins) |X| |O| | | |
| // Player 1 makes a move at (2, 2). | | |X|
toe.move(1, 1, 2); -> Returns 0 (no one wins) |X| |O| | |O|
| // Player 2 makes a move at (1, 1). | | |X|
toe.move(2, 0, 1); -> Returns 0 (no one wins) |X| |O| | |O|
| // Player 1 makes a move at (2, 0). |X| |X|
toe.move(1, 0, 2); -> Returns 0 (no one wins) |X| |O| |O|O|
| // Player 2 makes a move at (1, 0). |X| |X|
toe.move(2, 1, 1); -> Returns 1 (player 1 wins) |X| |O|
|O|O| | // Player 1 makes a move at (2, 1). |X|X|X|
Follow up: Could you do better than O(n2) per move()
operation?
348 is a locked problem. For each player's move, we can resort to
checkWin function in second solution for 1275. We show another solution
based on first solution of 1275, where 8 winning condition flags are
kept and each move only touches associated several flag variables.
def__init__(self, n:int): """ Initialize your data structure here. :type n: int """ self.row, self.col, self.diag1, self.diag2, self.n = [0] * n, [0] * n, 0, 0, n
defmove(self, row:int, col:int, player:int) -> int: """ Player {player} makes a move at ({row}, {col}). @param row The row of the board. @param col The column of the board. @param player The player, can be either 1 or 2. @return The current winning condition, can be either: 0: No one wins. 1: Player 1 wins. 2: Player 2 wins. """ if player == 2: player = -1
self.row[row] += player self.col[col] += player if row == col: self.diag1 += player if row + col == self.n - 1: self.diag2 += player
if self.n in [self.row[row], self.col[col], self.diag1, self.diag2]: return1 if -self.n in [self.row[row], self.col[col], self.diag1, self.diag2]: return2 return0
Optimal Strategy of
Tic-Tac-Toe
Tic-tac-toe and Gomoku (Connect Five in a Row) share the same rules
and are generally considered as M,n,k-game, where
board size range to M x N and winning condition changes to k.
ConnectNGame class implements M,n,k-game of MxM board size. It
encapsulates the logic of checking each move and also is able to undo
last move to facilitate backtrack in game search algorithm later.
defgetAvailablePositions(self) -> List[Tuple[int, int]]: return [(i,j) for i inrange(self.board_size) for j inrange(self.board_size) if self.board[i][j] == ConnectNGame.AVAILABLE]
defgetStatus(self) -> Tuple[Tuple[int, ...]]: returntuple([tuple(self.board[i]) for i inrange(self.board_size)])
Note that checkWin code is identical to second solution in 1275.
Minimax Strategy
Now we have Connect-N game logic, let's finish its minimax algorithm
to solve the game.
Define a generic strategy base class, where action method needs to be
overridden. Action method expects ConnectNGame class telling current
game state and returns a tuple of 2 elements, the first element is the
estimated or exact game result after taking action specified by second
element. The second element is of form Tuple[int, int], denoting the
position of the move, for instance, (1,1).
defminimax(self) -> Tuple[int, Tuple[int, int]]: game = self.game bestMove = None assertnot game.gameOver if game.currentPlayer == ConnectNGame.PLAYER_A: ret = -math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver result, oppMove = self.minimax() game.undo() ret = max(ret, result) bestMove = move if ret == result else bestMove if ret == 1: return1, move return ret, bestMove else: ret = math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver result, oppMove = self.minimax() game.undo() ret = min(ret, result) bestMove = move if ret == result else bestMove if ret == -1: return -1, move return ret, bestMove
We plot up to first 2 moves with code above. For first
player O, there are possibly 9 positions, where due to symmetry, only 3
kinds of moves, which we call corner, edge and center, respectively. The
following graph shows whatever 9 positions the first player takes, the
best result is draw. So solution of tic-tac-toe is draw.
Plot first step of 3 kinds of moves one by one below.
Tic-tac-toe Solution
and Number of States
An interesting question is the number of game states of tic-tac-toe.
A loosely upper bound can be derived by \(3^9=19683\), which includes lots of
inreachable states. This article Tic-Tac-Toe
(Naughts and Crosses, Cheese and Crackers, etc lists number of
states after each move. The total number is 5478.
Moves
Positions
Terminal Positions
0
1
1
9
2
72
3
252
4
756
5
1260
120
6
1520
148
7
1140
444
8
390
168
9
78
78
Total
5478
958
We can verify the number if we change a little of existing code to
code below.
if gameStatus in self.dpMap: return self.dpMap[gameStatus]
game = self.game bestMove = None assertnot game.gameOver if game.currentPlayer == ConnectNGame.PLAYER_A: ret = -math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver result, oppMove = self.minimax(game.getStatus()) self.dpMap[game.getStatus()] = result, oppMove else: self.dpMap[game.getStatus()] = result, move game.undo() ret = max(ret, result) bestMove = move if ret == result else bestMove self.dpMap[gameStatus] = ret, bestMove return ret, bestMove else: ret = math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos)
if result isNone: assertnot game.gameOver result, oppMove = self.minimax(game.getStatus()) self.dpMap[game.getStatus()] = result, oppMove else: self.dpMap[game.getStatus()] = result, move game.undo() ret = min(ret, result) bestMove = move if ret == result else bestMove self.dpMap[gameStatus] = ret, bestMove return ret, bestMove
if __name__ == '__main__': tic_tac_toe = ConnectNGame(N=3, board_size=3) strategy = CountingMinimaxStrategy() strategy.action(tic_tac_toe) print(f'Game States Number {len(strategy.dpMap)}')
Running the code proves the total number is 5478. Also illustrate
some small scale game configuration results.
3x3
4x4
k=3
5478 (Draw)
6035992 (Win)
k=4
9722011 (Draw)
k=5
According to Wikipedia
M,n,k-game, below are results for some game configuration.
3x3
4x4
5x5
6x6
k=3
Draw
Win
Win
Win
k=4
Draw
Draw
Win
k=5
Draw
Draw
What's worth mentioning is that Gomoku (Connect Five in a Row), of
board size MxM >= 15x15 is proved by L. Victor Allis to be Win.
defalpha_beta(self, gameStatus: Tuple[Tuple[int, ...]], alpha:int=None, beta:int=None) -> Tuple[int, Tuple[int, int]]: game = self.game bestMove = None assertnot game.gameOver if game.currentPlayer == ConnectNGame.PLAYER_A: ret = -math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver result, oppMove = self.alpha_beta(game.getStatus(), alpha, beta) game.undo() alpha = max(alpha, result) ret = max(ret, result) bestMove = move if ret == result else bestMove if alpha >= beta or ret == 1: return ret, move return ret, bestMove else: ret = math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver result, oppMove = self.alpha_beta(game.getStatus(), alpha, beta) game.undo() beta = min(beta, result) ret = min(ret, result) bestMove = move if ret == result else bestMove if alpha >= beta or ret == -1: return ret, move return ret, bestMove
Rewrite alpha beta pruning with DP, where we omit alpha and beta
parameters in alpha_beta_dp because lru_cache cannot specify effective
parameters. Instead, we keep alpha and beta in a stack variable and
maintain the stack according to alpha_bate_dp calling stack.
@lru_cache(maxsize=None) defalpha_beta_dp(self, gameStatus: Tuple[Tuple[int, ...]]) -> Tuple[int, Tuple[int, int]]: alpha, beta = self.alphaBetaStack[-1] game = self.game bestMove = None assertnot game.gameOver if game.currentPlayer == ConnectNGame.PLAYER_A: ret = -math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver self.alphaBetaStack.append((alpha, beta)) result, oppMove = self.alpha_beta_dp(game.getStatus()) self.alphaBetaStack.pop() game.undo() alpha = max(alpha, result) ret = max(ret, result) bestMove = move if ret == result else bestMove if alpha >= beta or ret == 1: return ret, move return ret, bestMove else: ret = math.inf for pos in game.getAvailablePositions(): move = pos result = game.move(*pos) if result isNone: assertnot game.gameOver self.alphaBetaStack.append((alpha, beta)) result, oppMove = self.alpha_beta_dp(game.getStatus()) self.alphaBetaStack.pop() game.undo() beta = min(beta, result) ret = min(ret, result) bestMove = move if ret == result else bestMove if alpha >= beta or ret == -1: return ret, move return ret, bestMove